#include "PanelView.h"

//BRect frame, const char *name, uint32 resizingMode, uint32 flags

CPanelView::CPanelView(BRect r, const char* name, uint32 mode, uint32 flags, bool raised)
	: BView(r, name, mode, flags)
{
	_IsRaised = raised;
	_backside = new BBitmap( r, B_RGB32_BIG );
}

CPanelView::~CPanelView()
{
	delete _backside;
}

void CPanelView::FrameResized( float x, float y )
{	
	BView::FrameResized( x, y );
}

void CPanelView::Draw(BRect r)
{
	BeginLineArray(4);
	if(_IsRaised)
		SetHighColor(_HighColor);
	else
		SetHighColor(_LowColor);
	MovePenTo(Bounds().right, 0);
	StrokeLine(BPoint(0,0));
	StrokeLine(BPoint(0,Bounds().bottom));

	if(_IsRaised)
		SetHighColor(_LowColor);
	else
		SetHighColor(_HighColor);
	StrokeLine(BPoint(Bounds().right, Bounds().bottom));
	StrokeLine(BPoint(Bounds().right, 0));
	EndLineArray();
}

void CPanelView::SetViewColor(rgb_color col)
{
	uchar t;	

	BView::SetViewColor(col);
	SetLowColor(col);
	
	col.red <= 0x33 ? t = 0 : t = col.red - 0x33; 
	_LowColor.red = t;
	col.green <= 0x33 ? t = 0 : t = col.green - 0x33; 
	_LowColor.green = t;
	col.blue <= 0x33 ? t = 0 : t = col.blue - 0x33; 
	_LowColor.blue = t;
	
	col.red >= 0xdd ? t = 0xff : t = col.red + 0x22; 
	_HighColor.red = t;
	col.green >= 0xdd ? t = 0xff : t = col.green + 0x22; 
	_HighColor.green = t;
	col.blue >= 0xdd ? t = 0xff : t = col.blue + 0x22; 
	_HighColor.blue = t;
}

rgb_color CPanelView::GetHighColor()
{
	return _HighColor;
}

rgb_color CPanelView::GetLowColor()
{
	return _LowColor;
}


void CPanelView::AttachedToWindow(void)
{
	if(Parent())
		SetViewColor(Parent()->ViewColor());
	else
		SetViewColor(0xde,0xdb,0xde);
}
